/**
 * @author Graham Cox, Apptree.net
 * @author Graham Miln, miln.eu
 * @author Contributions from the community
 * @date 2005-2013
 * @copyright This software is released subject to licensing conditions as detailed in DRAWKIT-LICENSING.TXT, which must accompany this source file.
 */

#import "DKGradient.h"

typedef union
{
#warning 64BIT: Inspect use of unsigned long
	unsigned long pixel;
	struct
	{
		unsigned char a;
		unsigned char r;
		unsigned char g;
		unsigned char b;
	}
	c;
}
pix_int;

@interface DKSweptAngleGradient : DKGradient
{
	CGImageRef		m_sa_image;
	CGContextRef	m_sa_bitmap;
	pix_int*		m_sa_colours;
	NSInteger				m_sa_segments;
	NSPoint			m_sa_centre;
	CGFloat			m_sa_startAngle;
	NSInteger				m_sa_img_width;
	BOOL			m_ditherColours;
}

+ (DKGradient*)		sweptAngleGradient;
+ (DKGradient*)		sweptAngleGradientWithStartingColor:(NSColor*) c1 endingColor:(NSColor*) c2;

- (void)			setNumberOfAngularSegments:(NSInteger) ns;
- (NSInteger)				numberOfAngularSegments;

- (void)			preloadColours;
- (void)			createGradientImageWithRect:(NSRect) rect;
- (void)			invalidateCache;

@end
